# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION < 6.30) ? 1 : 0);' 2>/dev/null || echo 0)

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

# TODO: Add these buildreqs when available
#BuildRequires: perl(DateTime::Format::HTTP)
#BuildRequires: perl(DateTime::Format::Mail)
#BuildRequires: perl(DateTime::Format::IBeat)
#BuildRequires: perl(Test::Pod::LinkCheck)

Name:		perl-DateTime-Format-Builder
Epoch:		1
Version:	0.81
Release:	2.%{__distinit}%{__distvers}
Summary:	Create DateTime parser classes and objects
Group:		Development/Libraries
License:	Artistic 2.0
URL:		http://search.cpan.org/dist/DateTime-Format-Builder/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DR/DROLSKY/DateTime-Format-Builder-%{version}.tar.gz
Patch0:		DateTime-Format-Builder-0.81-old-eumm.patch
Patch1:		DateTime-Format-Builder-0.81-old-Test::More.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Class::Factory::Util) >= 1.6
BuildRequires:	perl(DateTime) >= 1.00
BuildRequires:	perl(DateTime::Format::Strptime) >= 1.04
BuildRequires:	perl(Devel::Cycle) >= 1.07
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(lib)
BuildRequires:	perl(Params::Validate) >= 0.72
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Task::Weaken)
# Test::CPAN::Changes only available if we have Perl 5.10.0 onwards
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
BuildRequires:	perl(Test::CPAN::Changes)
%endif
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::Memory::Cycle)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.00
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Filter out bogus dependencies from the examples (rpm 4.9 onwards)
%global __requires_exclude perl\\(DateTime::Format::(HTTP|IBeat|Mail)\\)

%description
DateTime::Format::Builder creates DateTime parsers. Many string formats of
dates and times are simple and just require a basic regular expression to
extract the relevant information. Builder provides a simple way to do this
without writing reams of structural code.

Builder provides a number of methods, most of which you'll never need, or at
least rarely need. They're provided more for exposing of the module's innards
to any sub-classes, or for when you need to do something slightly beyond what
is expected.

%prep
%setup -q -n DateTime-Format-Builder-%{version}

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%if %{old_eumm}
%patch0
%endif

# We need to patch the test suite if we have an old version of Test::More
%if %{old_test_more}
%patch1 -p1
%endif

# Filter out bogus dependencies from the examples (prior to rpm 4.9)
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -Evx 'perl[(]DateTime::Format::(HTTP|IBeat|Mail)[)]'"
%define __perl_requires %{reqfilt}
# Filter out bogus provide of perl(main) on older distributions
%global provfilt /bin/sh -c "%{__perl_provides} | grep -Fvx 'perl(main)'"
%define __perl_provides %{provfilt}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
%{_fixperms} %{buildroot}

%check
make test RELEASE_TESTING=1

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README examples/
%{perl_vendorlib}/DateTime/
%{_mandir}/man3/DateTime::Format::Builder.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Dispatch.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Quick.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Regex.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Strptime.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::generic.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Tutorial.3pm*

%changelog
* Wed Jul 24 2013 Paul Howarth <paul@city-fan.org> 1:0.81-2
- Perl 5.18 rebuild

* Wed Apr  3 2013 Paul Howarth <paul@city-fan.org> 1:0.81-1
- Update to 0.81
  - Fixes to pass tests with DateTime 1.00
  - Build with Dist::Zilla
  - Add various release tests
- License changed to Artistic 2.0
- Switch to ExtUtils::MakeMaker flow
- No longer need to explicitly require perl(Class::Factory::Util) and
  perl(DateTime::Format::Strptime)
- Bump version requirements for perl(Class::Factory::Util), perl(DateTime),
  perl(DateTime::Format::Strptime) and perl(Params::Validate)
- BR: perl(Test::CPAN::Changes), perl(Test::EOL) and perl(Test::NoTabs) for
  new release tests and explicitly run those tests
- Add patches to support building with old ExtUtils::MakeMaker and Test::More
  versions

* Fri Jul 13 2012 Paul Howarth <paul@city-fan.org> 1:0.80-6
- Use Module::Build flow since we need Module::Build anyway
- Use a patch to fix character encodings rather than scripted iconv
- BR: perl(base), perl(Carp), perl(Devel::Cycle) ≥ 1.07, perl(lib) and
  perl(Scalar::Util)
- Drop redundant buildreq perl(Test::Signature)
- Drop support for old distributions prior to FC-3:
  - BR: perl(Test::Memory::Cycle) unconditionally
  - Don't need to define %%{perl_vendorlib)
  - Don't need to run test suite with LC_ALL=C

* Thu Jun 23 2011 Paul Howarth <paul@city-fan.org> 1:0.80-5
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Mar  4 2011 Paul Howarth <paul@city-fan.org> 1:0.80-4
- BR: perl(Test::Memory::Cycle) where possible for additional test coverage
- Fix dependency filter for rpm 4.9.x
- Filter bogus provides of perl(main) on older distributions

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 1:0.80-3
- Rebuild for perl 5.12.1 in Rawhide

* Wed May 19 2010 Paul Howarth <paul@city-fan.org> 1:0.80-2
- Fix dist tag for RHEL-6 Beta
- Recode README as UTF-8

* Sun Mar 14 2010 Paul Howarth <paul@city-fan.org> 1:0.80-1
- Update to 0.80 (clean up tests)
- Bump epoch since upstream promises to stick to 2 digits after the decimal
  point from now on
- Signature test dropped, so no need to go to great lengths to pass it now

* Thu Feb  4 2010 Paul Howarth <paul@city-fan.org> 0.7901-6
- Import from Fedora
- Tweak build process to pass signature test

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> 0.7901-5
- Rebuild against perl 5.10.1

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> 0.7901-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> 0.7901-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Mar  4 2008 Tom "spot" Callaway <tcallawa@redhat.com> 0.7901-2
- Rebuild for new perl

* Sat Jan 26 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.7901-1
- Update to 0.7901
- Additional docs
- Some spec rework

* Thu Aug 31 2006 Chris Weyl <cweyl@alumni.drew.edu> 0.7807-4
- Bump for mass rebuild

* Tue Aug 08 2006 Chris Weyl <cweyl@alumni.drew.edu> 0.7807-3
- Bump for release & build, not in that order

* Tue Aug 08 2006 Chris Weyl <cweyl@alumni.drew.edu> 0.7807-2
- Additional br's

* Fri Aug 04 2006 Chris Weyl <cweyl@alumni.drew.edu> 0.7807-1
- Initial spec file for F-E
